
/* Quicksort Partition Function */

/*@ requires 0 <= p <= r && \valid_range(A,p,r)  
  @*/
int partition (int A[], int p,int r) 
{ 
  int x = A[r]; 
  int tmp, j, i = p-1; 
  // NB i <= r not strong enough! 
  /*@ invariant p <= j <= r && p-1 <= i < j
    @ variant (r-j)
    @*/
  for(j=p; j<r; j++) 
    if (A[j] <= x) { 
      i++; 
      tmp = A[i];
      A[i] = A[j];
      A[j] = tmp;
    } 
  tmp = A[i+1];
  A[i+1] = A[r];
  A[r] = tmp;
  return i+1; 
}


