
#define N 10

/*@ requires \valid(x) && \valid(y) && x!=y
  @ ensures *x == \old( *x ) && *y == N-1
  @*/
void reference (int *x, int *y) 
{ 
  int i = 0;
  /*@ invariant 
    @    0 <= i <= N && (i>0 => *y == i-1)
    @ loop_assigns *y 
    @ variant N-i
    @*/
  while (i < N) {
    *y = i;
    i++;
  }
} 




